/******************************************************************************

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

******************************************************************************/

#include "mywriterfilter.hpp"

MyWriterFilter::MyWriterFilter(Settings &settings) {
     std::set<std::string> ret = settings.allParameters("errorWriter/rejectedNodes", "name");
     for (std::set<std::string>::const_iterator iter = ret.begin(); iter != ret.end(); ++iter) {
	  rejectedNodes.insert(*iter);
     }
}

short MyWriterFilter::acceptNode(const DOMNode *node) const {
     if (node->getNodeType() == DOMNode::ELEMENT_NODE) {
	  if (rejectedNodes.find(XMLtr(node->getNodeName())) != rejectedNodes.end()) {
	       return FILTER_REJECT;
	  }
     }
     return FILTER_ACCEPT;
}

unsigned long MyWriterFilter::getWhatToShow() const {
     return SHOW_ELEMENT;
}

void MyWriterFilter::setWhatToShow(unsigned long) {

}

