/******************************************************************************

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

******************************************************************************/

#include "utils.hpp"

namespace Utils {

     std::string escape(const std::string& str) {
	  static const char* expression = "(<)|(>)|(&)";
	  static const char* format = "(?1&lt;)(?2&gt;)(?3&amp;)";
	  static boost::regex exp(expression, boost::regbase::normal);
	  return regex_merge(str, exp, format);
     }
     
     std::string unescape(const std::string& str) {
	  static const char* expression = "(&lt;)|(&gt;)|(&amp;)";
	  static const char* format = "(?1<)(?2>)(?3&)";
	  static boost::regex exp(expression, boost::regbase::normal);
	  return regex_merge(str, exp, format);
     }

     void lowercase(std::string& str) {
	  std::transform(str.begin(), str.end(), str.begin(), toLower());
     }

     void uppercase(std::string& str) {
	  std::transform(str.begin(), str.end(), str.begin(), toUpper());
     }

}
