/******************************************************************************

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

******************************************************************************/

#ifndef WORDTAG_H
#define WORDTAG_H

class WordTag {
public:
     WordTag() {}
     WordTag(std::string  word, 
	     int          tag, 
	     unsigned int row, 
	     std::string  origWord,
	     int          origTag,
	     unsigned int origRow,
	     std::string  rest="", 
	     bool         blank = false, 
	     std::string  desc="") { 
	  set(word, tag, row, origWord, origTag, origRow, rest, blank, desc); 
     }
     void set(std::string s, int n) { 
	  data_word = s; data_tag = n;
     }
     void set(std::string  word, 
	      int          tag, 
	      unsigned int row, 
	      std::string  origWord,
	      int          origTag,	      
	      unsigned int origRow, 
	      std::string  rest="", 
	      bool         blank = false, 
	      std::string  desc="") {
	  data_word  = word;
	  data_tag   = tag;
	  data_row   = row;
	  orig_word  = origWord;
	  orig_tag   = origTag;
	  orig_row   = origRow;
	  data_blank = blank;
	  data_rest  = rest;
	  data_desc  = desc;
     }
     void setWord(const std::string& w) { data_word = w;  }
     void setRow(unsigned int r)     { data_row = r;      }
     const std::string& word() const { return data_word;  }
     int tag() const                 { return data_tag;   }
     unsigned int row() const        { return data_row;   }
     unsigned int orig() const       { return orig_row;   }
     const std::string& rest() const { return data_rest;  }
     bool blank() const              { return data_blank; }
     const std::string& desc() const { return data_desc;  }
     const std::string& origWord() const { return orig_word; }
     int origTag() const             { return orig_tag;   }
     void addDesc(const std::string toAdd) {
	  if (data_desc.length() != 0) {
	       data_desc += '/';
	  }
	  data_desc += toAdd;
     }
private:
     std::string  data_word;
     int          data_tag;
     unsigned int data_row;
     std::string  orig_word;
     int          orig_tag;
     unsigned int orig_row;
     bool         data_blank;
     std::string  data_rest;
     std::string  data_desc;
};

#endif
